/*
**  ClanLib SDK
**  Copyright (c) 1997-2011 The ClanLib Team
**
**  This software is provided 'as-is', without any express or implied
**  warranty.  In no event will the authors be held liable for any damages
**  arising from the use of this software.
**
**  Permission is granted to anyone to use this software for any purpose,
**  including commercial applications, and to alter it and redistribute it
**  freely, subject to the following restrictions:
**
**  1. The origin of this software must not be misrepresented; you must not
**     claim that you wrote the original software. If you use this software
**     in a product, an acknowledgment in the product documentation would be
**     appreciated but is not required.
**  2. Altered source versions must be plainly marked as such, and must not be
**     misrepresented as being the original software.
**  3. This notice may not be removed or altered from any source distribution.
**
**  Note: Some of the libraries ClanLib may link to may have additional
**  requirements or restrictions.
**
**  File Author(s):
**
**    Magnus Norddahl
*/

#pragma once

class CL_CSSTableCell
{
public:
	CL_CSSTableCell() : layout(0), row_span(0), col_span(0), minimum_width(0), maximum_width(0), height(0) { }

	CL_CSSLayoutTreeNode *layout;
	int row_span;
	int col_span;
	CL_CSSUsedValue minimum_width;
	CL_CSSUsedValue maximum_width;
	CL_CSSUsedValue height;
};

class CL_CSSTableColumn
{
public:
	CL_CSSTableColumn() : cell_width(0), minimum_width(0), maximum_width(0) { }

	std::vector<CL_CSSTableCell> rows;
	CL_CSSUsedValue cell_width;
	CL_CSSUsedValue minimum_width;
	CL_CSSUsedValue maximum_width;
};
